# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.patch_leave_accrual_record_request import PatchLeaveAccrualRecordRequest
from ..model.patch_leave_accrual_record_response import PatchLeaveAccrualRecordResponse


class LeaveAccrualRecord(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def patch(self, request: PatchLeaveAccrualRecordRequest,
              option: Optional[RequestOption] = None) -> PatchLeaveAccrualRecordResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: PatchLeaveAccrualRecordResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                   PatchLeaveAccrualRecordResponse)
        response.raw = resp

        return response
