# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.get_job_title_request import GetJobTitleRequest
from ..model.get_job_title_response import GetJobTitleResponse
from ..model.list_job_title_request import ListJobTitleRequest
from ..model.list_job_title_response import ListJobTitleResponse


class JobTitle(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def get(self, request: GetJobTitleRequest, option: Optional[RequestOption] = None) -> GetJobTitleResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetJobTitleResponse = JSON.unmarshal(str(resp.content, UTF_8), GetJobTitleResponse)
        response.raw = resp

        return response

    def list(self, request: ListJobTitleRequest, option: Optional[RequestOption] = None) -> ListJobTitleResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListJobTitleResponse = JSON.unmarshal(str(resp.content, UTF_8), ListJobTitleResponse)
        response.raw = resp

        return response
