# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.batch_delete_document_block_children_request import BatchDeleteDocumentBlockChildrenRequest
from ..model.batch_delete_document_block_children_response import BatchDeleteDocumentBlockChildrenResponse
from ..model.create_document_block_children_request import CreateDocumentBlockChildrenRequest
from ..model.create_document_block_children_response import CreateDocumentBlockChildrenResponse
from ..model.get_document_block_children_request import GetDocumentBlockChildrenRequest
from ..model.get_document_block_children_response import GetDocumentBlockChildrenResponse


class DocumentBlockChildren(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def batch_delete(self, request: BatchDeleteDocumentBlockChildrenRequest,
                     option: Optional[RequestOption] = None) -> BatchDeleteDocumentBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: BatchDeleteDocumentBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                            BatchDeleteDocumentBlockChildrenResponse)
        response.raw = resp

        return response

    def create(self, request: CreateDocumentBlockChildrenRequest,
               option: Optional[RequestOption] = None) -> CreateDocumentBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: CreateDocumentBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                       CreateDocumentBlockChildrenResponse)
        response.raw = resp

        return response

    def get(self, request: GetDocumentBlockChildrenRequest,
            option: Optional[RequestOption] = None) -> GetDocumentBlockChildrenResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: GetDocumentBlockChildrenResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    GetDocumentBlockChildrenResponse)
        response.raw = resp

        return response
