# Code generated by Lark OpenAPI.

from typing import *

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.list_interview_request import ListInterviewRequest
from ..model.list_interview_response import ListInterviewResponse


class Interview(object):
    def __init__(self, config: Config) -> None:
        self.config: Optional[Config] = config

    def list(self, request: ListInterviewRequest, option: Optional[RequestOption] = None) -> ListInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8), ListInterviewResponse)
        response.raw = resp

        return response
